@echo off
CD
color 0B

if exist "PA i-RETROPLAY.exe" (
echo File 1 ok
timeout /t 2 /nobreak
goto :MainMenu
) else (
goto :NONEXIST
)

timeout /t 2 /nobreak

:MainMenu
cls
title setup
pushd %~dp0
set "choice=-"
echo.
echo ====================================================================================
echo Project Arcade Sega Saturn Addon Installer
echo ====================================================================================
echo Hope this help patrons on settings up Project Arcade initially.
echo ====================================================================================
echo.
echo  [ 0 ] Default Sega Saturn Addon Install
echo  [ 1 ] Install only Batch File Fix
echo  [ - ] EXIT
echo.
echo =====================================================================================
echo Choose ony the numbers inside the brackets. Then letter y for yes or letter n for no. 
echo Press e to go back to previous menu. 
echo =====================================================================================
set /p choice= Choice: 
if %choice%==0 goto:UNO
if %choice%==1 goto:FIXESONLY 
if %choice%==- goto:EXIT
goto:MainMenu

:FIXESONLY

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Extracting FIX Files... please wait
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 2 /nobreak

"C:\Program Files\7-Zip\7z.exe" x MASTERPATCHER\SATURNBATCHFILEFIX.7z -oMASTERPATCHER -pjolygim -y
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Moving Files... please wait
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 2 /nobreak
MD "MASTERPATCHER\SATURNBATCHFILEBACKUP\US"
MD "MASTERPATCHER\SATURNBATCHFILEBACKUP\JP"
MD "collections\2 Sega Saturn\roms"
MD "collections\Saturn Japan\roms"
move "collections\2 Sega Saturn\roms\*.bat" "MASTERPATCHER\SATURNBATCHFILEBACKUP\US"
move "collections\Saturn Japan\roms\*.bat" "MASTERPATCHER\SATURNBATCHFILEBACKUP\JP"

goto:BATMOVE1

:BATMOVE1
set "Source=MASTERPATCHER\SATURNBATCHFILEFIX\US"
set "Destin=collections\2 Sega Saturn\roms"
echo. & echo  Processing . . .
              for /r "%Source%" %%x in (*.bat) do move "%%x" "%Destin%" >nul
        echo  Processing Complete.
echo. & echo ^>processing, please wait . . . & timeout /t 5 /nobreak >nul
goto :BATMOVE2

:BATMOVE2
set "Source=MASTERPATCHER\SATURNBATCHFILEFIX\JP"
set "Destin=collections\Saturn Japan\roms"
echo. & echo  Processing . . .
              for /r "%Source%" %%x in (*.bat) do move "%%x" "%Destin%" >nul
        echo  Processing Complete.
echo. & echo ^>processing, please wait . . . & timeout /t 5 /nobreak >nul
goto :BATMOVEOK

:BATMOVEOK
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Fix installed..
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 2 /nobreak
goto :MainMenu

:UNO
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo checking directory please wait...
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 5 /nobreak
goto :START

:START
if exist "PA i-RETROPLAY.exe" (
echo File 1 ok
timeout /t 2 /nobreak
goto :SECONDCHECK
) else (
goto :NONEXIST
)

timeout /t 2 /nobreak

:SECONDCHECK
if exist "MASTERPATCHER\SEGASATURN_ADDON_UPDATE_i-RETROPLAY_UPDATE_2025.7z" (
echo File 2 ok
timeout /t 2 /nobreak
goto :THIRDCHECK
) else (
goto :NONEXIST2
)


:THIRDCHECK
if exist "C:\Program Files\7-Zip\7z.exe" (
echo File 3 ok
timeout /t 2 /nobreak
goto :GAMECHECK
) else (
goto :NONEXIST3
)

:GAMECHECK
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Checking Game Files..  please wait...
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 5 /nobreak
if exist "MASTERPATCHER\SATURN_ROMSUSA.7z.001" (
echo all files ok
timeout /t 15 /nobreak
goto :PROCEED


:NONEXISTGAMES
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo WARNING!!! WARNING!!! WARNING!!! WARNING!!! WARNING!!!
echo Warning missing games files.
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 15 /nobreak
goto :NOGAMES


:NOGAMES
set /P c=Do you wish to continue without or missing game files? (Y/N)
if /I “%c%” EQU “Y” goto :Sure
if /I “%c%” EQU “N” goto :ABORT
goto :NONEXISTGAMES

:Sure
echo ============================================================
echo Continue without game files anyway. Manual install game files later.  
echo ============================================================
set /P c=Are you sure? (Y/N)
if /I “%c%” EQU “Y” goto :PROCEED
if /I “%c%” EQU “N” goto :ABORT

:NONEXIST
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ERROR!!!  ERROR!!! ERROR!!! ERROR!!! ERROR!!! ERROR!!!
echo PA i-RETROPLAY.exe does not exist
echo make sure to place the patcher in the root of Project Arcade
echo Example : D:\ProJectArcadeBitsBits
echo Installer will now exit.
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
pause
goto :ABORT

:NONEXIST2
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ERROR!!!  ERROR!!! ERROR!!! ERROR!!! ERROR!!! ERROR!!! 
echo SEGASATURN_ADDON_UPDATE_i-RETROPLAY_UPDATE_2025.7z does not exist
echo make sure to place the patcher in the root of Project Arcade
echo Example : D:\ProJectArcadeBitsBits\MASTERPATCHER
echo Installer will now exit.
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
pause
goto :ABORT


:NONEXIST3
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ERROR!!!  ERROR!!! ERROR!!! ERROR!!! ERROR!!! ERROR!!! 
echo 7zip not installed
echo https://www.7-zip.org/
echo Installer will now exit.
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
pause
goto :ABORT





:PROCEED
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Project Arcade i-RetroPlay SEGA SATURN Addon Installer
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 3 /nobreak

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Requirements:Project Arcade i-RetroPLAY BASEBUILD
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 3 /nobreak


echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Make sure you have enough storage space before continuing.
echo you need atleast 50GB for data files and 10GB on C:\ drive to avoid issues
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 3 /nobreak

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Let's go...
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
pause

echo Processing the files please wait...
timeout /t 3 /nobreak

MD "MASTERPATCHER\BACKUPSATURN\collections\2 Sega Saturn"
MD "MASTERPATCHER\BACKUPSATURN\collections\Saturn Japan"

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Creating needed folders please wait
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 3 /nobreak

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo backing up the folders and files please wait
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 5 /nobreak

move "collections\2 Sega Saturn\include.txt" "MASTERPATCHER\BACKUPSATURN\collections\2 Sega Saturn\include.txt"
move "collections\Saturn Japan\include.txt" "MASTERPATCHER\BACKUPSATURN\collections\Saturn Japan\include.txt"


echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Extracting Base Files... please wait
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 10 /nobreak

"C:\Program Files\7-Zip\7z.exe" x MASTERPATCHER\SEGASATURN_ADDON_UPDATE_i-RETROPLAY_UPDATE_2025.7z  -pjolygim -y

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Extracting Seaga Saturn US Game Files... please wait
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 10 /nobreak

"C:\Program Files\7-Zip\7z.exe" x MASTERPATCHER\SATURN_ROMSUSA.7z.001  -pjolygim -y

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Moving Game Files to roms folder... please wait...
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 5 /nobreak

move "roms" "collections\2 Sega Saturn"

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Extracting Seaga Saturn Japanese Game Files... please wait
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 5 /nobreak

"C:\Program Files\7-Zip\7z.exe" x MASTERPATCHER\SATURN_ROMSJAPAN.7z.001  -pjolygim -y

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Moving Game Files to roms folder... please wait...
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 5 /nobreak

move "roms" "collections\Saturn Japan"
goto :FIXESONLY2

:FIXESONLY2
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Extracting FIX Files... please wait
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 2 /nobreak

"C:\Program Files\7-Zip\7z.exe" x MASTERPATCHER\SATURNBATCHFILEFIX.7z -oMASTERPATCHER -pjolygim -y
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Moving Files... please wait
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 2 /nobreak
MD "MASTERPATCHER\SATURNBATCHFILEBACKUP\US"
MD "MASTERPATCHER\SATURNBATCHFILEBACKUP\JP"
move "collections\2 Sega Saturn\roms\*.bat" "MASTERPATCHER\SATURNBATCHFILEBACKUP\US"
move "collections\Saturn Japan\roms\*.bat" "MASTERPATCHER\SATURNBATCHFILEBACKUP\JP"

goto:BATMOVE1-A

:BATMOVE1-A
set "Source=MASTERPATCHER\SATURNBATCHFILEFIX\US"
set "Destin=collections\2 Sega Saturn\roms"
echo. & echo  Processing . . .
              for /r "%Source%" %%x in (*.bat) do move "%%x" "%Destin%" >nul
        echo  Processing Complete.
echo. & echo ^>processing, please wait . . . & timeout /t 5 /nobreak >nul
goto :BATMOVE2-A

:BATMOVE2-A
set "Source=MASTERPATCHER\SATURNBATCHFILEFIX\JP"
set "Destin=collections\Saturn Japan\roms"
echo. & echo  Processing . . .
              for /r "%Source%" %%x in (*.bat) do move "%%x" "%Destin%" >nul
        echo  Processing Complete.
echo. & echo ^>processing, please wait . . . & timeout /t 5 /nobreak >nul
goto :BATMOVEOK-A

:BATMOVEOK-A
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo Fix installed..
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 2 /nobreak
goto :CLEANUP


:CLEANUP
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo cleaning up... please wait...
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 3 /nobreak

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo All done.. This window will auto close.. Thanks
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
timeout /t 3 /nobreak

move "SEGASATURN_ADDON_UPDATE_i-RETROPLAY_UPDATE_2025.7z" "MASTERPATCHER\SEGASATURN_ADDON_UPDATE_i-RETROPLAY_UPDATE_2025.7z"
move "SEGASATURN ADDON INSTALLER.bat" "MASTERPATCHER\SEGASATURN ADDON INSTALLER.bat"

echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo All done..
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
echo ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
pause

:ABORT
exit


